Load loadpath.
Require Import ssreflect ssrbool ssrnat eqtype ssrfun seq rels ordtype.
Require Import Eqdep prelude.
Set Implicit Arguments.
Unset Strict Implicit.
Unset Printing Implicit Defensive.

(* C - type of external choice *)
(*
Structure sched C := ChoiceAct of C | SeqRet | SeqStep of sched C |  
                     ParRet | ParL of sched C | ParR of sched C.
Implicit Arguments SeqRet [C].
Implicit Arguments ParRet [C].
*)

(* I omit the external choice for now *)

Structure sched := ChoiceAct | SeqRet | SeqStep of sched |  
                   ParRet | ParL of sched | ParR of sched | 
                   HideStep of sched | HideRet | 
                   ExtendStep of sched | ExtendRet.

(* an alternative inductions on schedules *)
(* to group together common cases for ParL and ParR *)

Lemma sched_ind' (P : sched -> Prop) : 
       P ChoiceAct ->
       P SeqRet ->
       (forall s, P s -> P (SeqStep s)) ->
       P ParRet ->
       (forall s, P s -> P (ParL s) /\ P (ParR s)) ->
       (forall s, P s -> P (HideStep s)) ->
       P HideRet ->
       (forall s, P s -> P (ExtendStep s)) ->
       P ExtendRet ->
       forall s, P s.
Proof. by move=>H1 H2 H3 H4 H5 H6 H7 H8 H9; elim=>// s; case/H5. Qed.




